/***************************************************************************/
/*  CIS-791:  Multimedia Systems                                           */
/*  Homework 2                                                             */
/*  By: Praveen Kumar Adusumilli                                           */
/***************************************************************************/

#include <Xm/MainW.h>
#include <Xm/Label.h>
#include <Xm/MessageB.h>
#include <Xm/FileSB.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/DrawingA.h>
#include <Xm/RowColumn.h>
#include <Xm/PanedW.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/TextF.h>
#include <Xm/LabelG.h>
#include <Xm/ToggleBG.h>
#include <Xm/Frame.h>
Widget toplevel, label;
int flag1, flag2;
#define limit 200

main (argc, argv)
int argc;
char *argv[];
{
  Widget main_window, widget, menubar;
  Widget frame1;
  Widget quit_button, form, radio_box;
  Widget button_1, button_2, button_3, button_4;
  Widget text_area;
  Widget selection_1, selection_2;
  XtAppContext app;
  XmString file,help,open;
  void file_cb(), help_cb();
  void button_1_pressed_cb(), button_2_pressed_cb();
  void button_3_pressed_cb(), button_4_pressed_cb();
  void quit_pressed_cb();
  void text_area_cb();
  void selection_1_cb(), selection_2_cb();

  XtSetLanguageProc (NULL, NULL, NULL);

  flag1 = 0;
  flag2 = 1;
/*****************************************************************************/
/* Setting up the main window of size 400x400 fixed                          */
/*****************************************************************************/

    /* Initialize toolkit and parse command line options. */
    toplevel = XtVaAppInitialize (&app, "Howework2",
        NULL, 0, &argc, argv, NULL,
        XmNminWidth,     limit+60,
        XmNminHeight,    limit - 40,
        XmNmaxWidth,     limit+60,
        XmNmaxHeight,    limit - 40,
        XmNbaseWidth,    5,
        XmNbaseHeight,   5,
        XmNwidthInc,     5,
        XmNheightInc,    5,
        NULL);

    /* main window contains a MenuBar and a Label displaying a pixmap */
    main_window = XtVaCreateManagedWidget ("main_window",
        xmMainWindowWidgetClass,   toplevel,
        /*
        XmNscrollBarDisplayPolicy, XmAS_NEEDED,
        XmNscrollingPolicy,        XmAUTOMATIC,*/
        NULL);



/*****************************************************************************/
/* Setting up a menu bar with file and help as the options                   */
/*****************************************************************************/

    /* Create a simple MenuBar that contains two menus */
    file = XmStringCreateLocalized ("File");
    help = XmStringCreateLocalized ("Help");
    menubar = XmVaCreateSimpleMenuBar (main_window, "menubar",
        XmVaCASCADEBUTTON, file, 'F',
        XmVaCASCADEBUTTON, help, 'H',
        NULL);
    XmStringFree (file);

if (widget = XtNameToWidget (menubar,"button_1"))
       XtVaSetValues (menubar, XmNmenuHelpWidget, widget, NULL);

    open = XmStringCreateLocalized ("Open...");
    XmVaCreateSimplePulldownMenu (menubar, "file_menu", 0, file_cb,
        XmVaPUSHBUTTON, open, 'N', NULL, NULL,
        NULL);
    XmStringFree (open); 


    /* second menu is the help menu -- callback is help_cb() */
    XmVaCreateSimplePulldownMenu (menubar, "help_menu", 1, help_cb,
        XmVaPUSHBUTTON, help, 'H', NULL, NULL,
        NULL); 

    XmStringFree (help);

    XtManageChild (menubar);


/*****************************************************************************/
/*  First we create a FORM window where we attach all our buttons            */
/*****************************************************************************/

form = XtVaCreateWidget ("form",
	        xmFormWidgetClass, main_window,
                NULL);



/*****************************************************************************/
/* Adding BUTTON_1 to the top left hand corner of the screen                 */
/*****************************************************************************/

button_1 = XtVaCreateManagedWidget("button_1",
		  xmPushButtonWidgetClass, form,
		  XmNx,     5,
		  XmNy,     5,
                  NULL);
XtAddCallback (button_1, XmNactivateCallback, button_1_pressed_cb, NULL);

XtManageChild (button_1);


/*****************************************************************************/
/* Adding BUTTON_2 to the right of BUTTON_1                                  */
/*****************************************************************************/

button_2 = XtVaCreateManagedWidget("button_2",
		  xmPushButtonWidgetClass, form,
		  XmNleftAttachment,    XmATTACH_WIDGET,
		  XmNleftWidget,      button_1,
		  XmNtopAttachment,   XmATTACH_OPPOSITE_WIDGET,
		  XmNtopWidget,       button_1,
                  NULL);
XtAddCallback (button_2, XmNactivateCallback, button_2_pressed_cb, NULL);

XtManageChild (button_2);

/*****************************************************************************/
/* Adding BUTTON_3 below BUTTON_1                                            */
/*****************************************************************************/

button_3 = XtVaCreateManagedWidget("button_3",
		  xmPushButtonWidgetClass, form,
		  XmNtopAttachment,    XmATTACH_WIDGET,
		  XmNtopWidget,      button_1,
		  XmNleftAttachment,   XmATTACH_OPPOSITE_WIDGET,
		  XmNleftWidget,       button_1,
                  NULL);
XtAddCallback (button_3, XmNactivateCallback, button_3_pressed_cb, NULL);
XtManageChild (button_3);

/*****************************************************************************/
/* Adding BUTTON_4 below BUTTON_2 and right of BUTTON_3                      */
/*****************************************************************************/

button_4 = XtVaCreateManagedWidget("button_4",
		  xmPushButtonWidgetClass, form,
		  XmNtopAttachment,    XmATTACH_WIDGET,
		  XmNtopWidget,      button_2,
		  XmNleftAttachment,   XmATTACH_WIDGET,
		  XmNleftWidget,       button_3,
                  NULL);
XtAddCallback (button_4, XmNactivateCallback, button_4_pressed_cb, NULL);
XtManageChild (button_4);


/*****************************************************************************/
/*  Adding the QUIT button at the bottom right hand corner of the screen     */
/*****************************************************************************/

quit_button = XtVaCreateManagedWidget("Quit",
		  xmPushButtonWidgetClass, form,
		  XmNx,                    limit,
		  XmNy,                    limit - 100,
                  NULL);
XtAddCallback (quit_button, XmNactivateCallback, quit_pressed_cb, NULL);
XtManageChild (quit_button);


/*****************************************************************************/
/* Adding a text box at the bottom of the screen, just above the QUIT button */
/*****************************************************************************/

text_area = XtVaCreateManagedWidget ("text_area",
                  xmTextFieldWidgetClass,    form,
		  XmNtraversalOn,            True,
		  XmNrightAttachment,        XmATTACH_FORM,
		  XmNleftAttachment,         XmATTACH_POSITION,
		  XmNy,                      limit - 130, 
		  NULL);
XtAddCallback (text_area, XmNactivateCallback, text_area_cb, NULL);

XtManageChild (text_area);


/*****************************************************************************/
/* Adding two radio boxes to the upper right of the screen                   */
/*****************************************************************************/

frame1 = XtVaCreateManagedWidget ("frame1",
                        xmFrameWidgetClass, form,
			XmNx,     130,
			XmNy,     5,
			NULL);

radio_box = XmCreateRadioBox (frame1, "radio_box",
			      NULL, 0);

selection_1 = XtVaCreateManagedWidget ("Selection_1",
			xmToggleButtonGadgetClass, radio_box,
        		        NULL);
XtAddCallback (selection_1, XmNvalueChangedCallback, selection_1_cb, NULL);


selection_2 = XtVaCreateManagedWidget ("Selection_2",
		        xmToggleButtonGadgetClass, radio_box,
				NULL);
XtAddCallback (selection_2, XmNvalueChangedCallback, selection_2_cb, NULL);

    XtManageChild (selection_1);
    XtManageChild (selection_2);
    XtManageChild (radio_box);
    XtManageChild (form);
    XtRealizeWidget (toplevel);
    XtAppMainLoop (app);
}

 


/*****************************************************************************/
/*  All the CALLBACK routines are defined below                              */
/*****************************************************************************/

void file_cb (widget, client_data, call_data)
Widget widget;
XtPointer client_data;
XtPointer call_data;
{

    static Widget dialog; /* make it static for reuse */
    extern void load_pixmap();
    int item_no = (int) client_data;

    /* "Open" was selected.  Create a Motif FileSelectionDialog w/callback */
    if (!dialog) {
        dialog = XmCreateFileSelectionDialog (toplevel, "file_sel", NULL, 0);
        XtAddCallback (dialog, XmNokCallback, XtUnmanageChild, NULL);
        XtAddCallback (dialog, XmNcancelCallback, XtUnmanageChild, NULL);
    }
    XtManageChild (dialog);
    XtPopup (XtParent (dialog), XtGrabNone);

}




void help_cb (widget, client_data, call_data)
Widget widget;
XtPointer client_data;
XtPointer call_data;
{

    static Widget dialog;

    if (!dialog) {
        Arg args[5];
        int n = 0;
        XmString msg = XmStringCreateLtoR ("Praveen K. Adusumilli",

                                             XmFONTLIST_DEFAULT_TAG);
        XtSetArg (args[n], XmNmessageString, msg); n++;
        dialog = XmCreateInformationDialog (toplevel, "help_dialog", args, n);
    }
    XtManageChild (dialog);
    XtPopup (XtParent (dialog), XtGrabNone);


}


void button_1_pressed_cb (widget, client_data, call_data)
Widget widget;
XtPointer client_data;
XtPointer call_data;
{

printf ("Button_1 was pushed\n");

}

void button_4_pressed_cb (widget, client_data, call_data)
Widget widget;
XtPointer client_data;
XtPointer call_data;
{

printf ("Button_4 was pushed\n");

}
void button_3_pressed_cb (widget, client_data, call_data)
Widget widget;
XtPointer client_data;
XtPointer call_data;
{

printf ("Button_3 was pushed\n");

}

void button_2_pressed_cb (widget, client_data, call_data)
Widget widget;
XtPointer client_data;
XtPointer call_data;
{

printf ("Button_2 was pushed\n");

}

void quit_pressed_cb (widget, client_data, call_data)
Widget widget;
XtPointer client_data;
XtPointer call_data;
{

exit(1);

}


void text_area_cb (text_to_write, client_data, call_data)
Widget text_to_write;
XtPointer client_data;
XtPointer call_data;
{
 char *value = XmTextFieldGetString (text_to_write);

 printf ("%s\n", value);

 XtFree (value);
 XmTextSetString (text_to_write, NULL);
}


void selection_1_cb (widget, client_data, call_data)
Widget widget;
XtPointer client_data;
XtPointer call_data;
{
XmToggleButtonCallbackStruct *cbs = (XmToggleButtonCallbackStruct *) call_data;

if (cbs->set == True)
  {
   if (flag1 == 0)
     {
       printf ("Selection_1 was selected.\n");
       flag1 = 1;
       flag2 = 0;
     }
    else
      {
	flag1 = 0;
        flag2 = 1;
      }
 }
}

void selection_2_cb (widget, client_data, call_data)
Widget widget;
XtPointer client_data;
XtPointer call_data;
{
XmToggleButtonCallbackStruct *cbs = (XmToggleButtonCallbackStruct *) call_data;

if (cbs->set == True)
  {
   if (flag2 == 0)
     {
       printf ("Selection_2 was selected.\n");
       flag2 = 1;
       flag1 = 0;
     }
    else 
      {
	flag2 = 0;
        flag1 = 1;
      }
 }
}
